/**
* @author SamsamTS 
*/
import com.samsamts.Events.Event;
import com.samsamts.Events.EventArgs;
import com.samsamts.Events.EventHandler;
import com.samsamts.Utils.Scheduler;
import com.samsamts.Utils.ScheduleEventArgs;
import com.samsamts.Utils.LoopEventArgs;

class com.samsamts.Utils.Loop
{
	//{ Author properties
	public static var className:String = "Loop";
	public static var classPackage:String = "com.samsamts.Utils";
	public static var version:String = "1.0.0";
	public static var author:String = "SamsamTS";
	public static var link:String = "http://www.samsamts.com/blog/";
	//}
	
	//{ Events
	public var OnStart:Event;
	public var OnComplete:Event;
	//}

	public function Loop(start:Number, end:Number, step:Number, handler:EventHandler)
	{
		OnStart = new Event();
		OnComplete = new Event();

		m_running = false;
		m_start = start;
		m_end = end;
		m_step = step;
		m_handler = handler;
	}

	//{ Public
	public function Start():Void
	{
		if(m_running)
			return;
		m_current = m_start;
		m_running = true;
		Scheduler.Add(new EventHandler(this, OnSchedule));
	}

	public function Break():Void
	{
		m_running = false;
	}
	public function toString():String
	{
		return "[Loop]";
	}
	//}

	//{ Private
	private var m_running:Boolean;
	private var m_start:Number;
	private var m_current:Number;
	private var m_end:Number;
	private var m_step:Number;
	private var m_handler:EventHandler;
	
	private function OnSchedule(sender:Object, args:ScheduleEventArgs)
	{
		var startTime:Number = getTimer();
		do
		{
			if(!m_running)
			{
				Scheduler.Remove(new EventHandler(this, OnSchedule));
				OnComplete.Trigger(this, new EventArgs());
				return;
			}
			m_handler.Call(this, new LoopEventArgs(m_current));
			if(m_current == m_end)
			{
				m_running = false;
				Scheduler.Remove(new EventHandler(this, OnSchedule));
				OnComplete.Trigger(this, new EventArgs());
				return;
			}
			m_current += m_step;
		}
		while(args.ScheduleTime - (getTimer() - startTime) > 0);
	}
	//}
}