/**
* @author SamsamTS
*/
import com.samsamts.Events.Event;
import com.samsamts.Events.EventHandler;
import com.samsamts.AnimationCtrl.Animation;
import com.samsamts.Utils.ScheduleEventArgs;

class com.samsamts.Utils.Scheduler
{
	//{ Author properties
	public static var className:String = "Scheduler";
	public static var classPackage:String = "com.samsamts.Utils";
	public static var version:String = "1.0.0";
	public static var author:String = "SamsamTS";
	public static var link:String = "http://www.samsamts.com/blog/";
	//}

	//{ Public
	/**
	* Add an EventHandler
	* @param	handler
	* @return	The event
	*/
	public static function Add(handler:EventHandler):Void
	{
		Remove(handler);
		$instance.m_arrHandlers.push(handler);
		
		if(Animation.OnAfterFrame.Count == 0)
			Animation.OnAfterFrame.Add(new EventHandler($instance, $instance.Trigger));
			
	}
	/**
	* Remove an EventHandler
	* @param	handler
	* @return	The event
	*/
	public static function Remove(handler:EventHandler):Void
	{
		for (var i : Number = 0; i < $instance.m_arrHandlers.length; i++)
		{
			if($instance.m_arrHandlers[i].Compare(handler))
			{
				$instance.m_arrHandlers.splice(i,1);
				if($instance.m_pos >= i) $instance.m_pos--;
				return;
			}
		}
		if($instance.m_arrHandlers.length == 0)
		{
			$instance.m_pos = 0;
			Animation.OnAfterFrame.Remove(new EventHandler($instance, $instance.Trigger));
		}
	}
	/**
	* Get the number of registered event handlers
	* @return number of registered event handlers
	*/
	public static function get Count():Number
	{
		return $instance.m_arrHandlers.length;
	}
	
	public function toString():String
	{
		return "[Scheduler]";
	}
	//}
	
	//{ Private
	private var m_arrHandlers:Array;
	private var m_name:String;
	private var m_ratio:Number;
	private var m_pos:Number;

	private static var $instance:Scheduler = new Scheduler();
	private function Scheduler()
	{
		m_arrHandlers = new Array();
		m_ratio = 0.9;
		m_pos = 0;
	}
	public function Trigger():Void
	{
		var remainingTime:Number = Number(Animation.GetRemainingTime()) - (1000/Animation.GetFrameRate())*(1-m_ratio);
		var l:Number = m_arrHandlers.length;
		while(remainingTime > 0)
		{
			var startTime:Number = getTimer();
			var scheduleTime:Number = remainingTime / l;
			if(!m_arrHandlers[m_pos].Call(this, new ScheduleEventArgs(scheduleTime)))
				Remove(m_arrHandlers[m_pos]);
			m_pos = (m_pos+1)%l;
			remainingTime -= getTimer()-startTime;
		}	
	}
	//}
}
